# -*- coding: utf-8 -*-
from setuphelpers import *


##app_scheduled_tasks = [
##    "MicrosoftEdgeUpdateBrowserReplacementTask",
##    "MicrosoftEdgeUpdateTaskMachineCore",
##    "MicrosoftEdgeUpdateTaskMachineUA",
##    "MicrosoftEdgeUpdateTaskUser"
##]

app_services = [
    "MicrosoftEdgeElevationService",
    "edgeupdatem",
    "edgeupdate",
]

def install():
    # Declaring local variables
    bin_name = glob.glob("MicrosoftEdgeEnterprise*.msi")[0]
    app_uninstallkey = get_msi_properties(bin_name)["ProductCode"]

    # Disabling automatic updates (https://admx.help/?Category=EdgeChromium&Policy=Microsoft.Policies.Update::Pol_DefaultUpdatePolicy)
    registry_deletekey(HKEY_LOCAL_MACHINE, r"SOFTWARE\Policies\Microsoft", "EdgeUpdate")
    registry_set(HKEY_LOCAL_MACHINE, r"SOFTWARE\Policies\Microsoft\EdgeUpdate", "UpdateDefault", 0)
    registry_set(HKEY_LOCAL_MACHINE, r"SOFTWARE\Policies\Microsoft\EdgeUpdate", "DisableAutoUpdateChecksCheckboxValue", 1)
    registry_set(HKEY_LOCAL_MACHINE, r"SOFTWARE\Policies\Microsoft\EdgeUpdate", "AutoUpdateCheckPeriodMinutes", 0)


    ps_scheduled_tasks = run_powershell(f'Get-ScheduledTask -TaskPath \ | Where-Object TaskName -Like "MicrosoftEdgeUpdate*"')
    # Stopping application scheduled tasks
    if ps_scheduled_tasks:
        for task_name in ps_scheduled_tasks:
            curr_task_name = task_name['TaskName']
            try:
                run(rf'schtasks /end /tn "{curr_task_name}"')
            except:
                print(f"Unable to stop the task_name: {curr_task_name}")

    # Stopping application services
    for service_name in app_services:
        if service_installed(service_name):
            try:
                if service_is_running(service_name):
                    service_stop(service_name)
            except:
                print(f"Unable to stop the service: {service_name}")

    # for s in installed_softwares("Edge"):
    #     print("Found: %s (%s)" % (s["name"], s["version"]))
    #     print(s)

    if windows_version() < WindowsVersions.Windows10:
        # Uninstalling newer versions of the software for W7/8
        for to_uninstall in installed_softwares(name="^Microsoft Edge$"):
            if Version(to_uninstall["version"]) > Version(control.get_software_version()) or force:
                print("Removing: %s (%s)" % (to_uninstall["name"], to_uninstall["version"]))
                try:
                    killalltasks(control.get_impacted_process_list())
                    run(uninstall_cmd(to_uninstall["key"]))
                    wait_uninstallkey_absent(to_uninstall["key"])
                except Exception as e:
                    print(e)
                    print("Remove failed: %s (%s)\nContinuing..." % (to_uninstall["name"], to_uninstall["version"]))

    # Installing the package
    install_msi_if_needed(
        bin_name,
        min_version=control.get_software_version(),
        timeout=900,
        remove_old_version=True,
    )

    if windows_version() > WindowsVersions.Windows10:
        # Avoiding the usage by WAPT of the app built-in Uninstallstring for Windows 10+
        uninstallkey.remove(app_uninstallkey)

    # Removing desktop shortcut if allowed
    if params.get("remove_desktop_shortcut"):
        remove_desktop_shortcut(control.name)


    ps_scheduled_tasks = run_powershell(f'Get-ScheduledTask -TaskPath \ | Where-Object TaskName -Like "MicrosoftEdgeUpdate*"')
    if ps_scheduled_tasks:
        for tasks in ps_scheduled_tasks:
            curr_task_name = tasks['TaskName']
                # Disabling application scheduled tasks
            try:
                disable_task(curr_task_name)
            except:
                print(f"Unable to disable the task_name: {curr_task_name}")

    # Changing default start mode of the application services
    for service_name in app_services:
        set_service_start_mode(service_name, "Manual")
